/* 
 * Thomas Pantzer: februar_main.cc, Version: v0.1a  11.02.2000 04:06 
 * 
 * 
 * Copyright 2000 by Thomas Pantzer
 * 
 * Permission to use, copy, modify, and distribute this software for noncommercial 
 * use and without fee is hereby granted, provided that the above copyright notice 
 * appear in all copies and that both that copyright notice and this permission 
 * notice appear in supporting documentation, and that the name of the Author not be 
 * used in advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission. The Author makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is" 
 * without expressed or implied warranty. 
 * 
 * 
 * pantec@isys2.informatik.uni-leipzig.de   (Thomas Pantzer) 
 * 
 */





#include "forms.h"


#define MAIN_G
#include "februar.h"
#include "copyright.h"


#define realday   (1.0 / 365.25)
#define longday   (1.0 / 365.0)
#define shortday  (1.0 / 366.0)




char leap_year(int y)
{
	if ((y % 4) == 0)
	   {
	    if ((y % 100) == 0)
	       {
		if ((y % 400) == 0)
		   return true;

		return false;
	       }
	    
	    return true;
	   }
	
	return false;
}

double addof(int year)
{
	if (leap_year(year) == true)
	    return shortday;
	
	return longday;
}



int timecalc(int birthyear, int thisyear, double x)
{
     int lifetime = thisyear - birthyear; 

     int k = birthyear;
	
     double rdays = ((double)lifetime * 365.25);
     double cdays = (1.0 -x);
	
     int fdays = 0;


      do { 	
          cdays += 365.0;

	  k++;
	  fdays = 0;

	  if (cdays >= rdays)
	      break;	 

	  fdays++;

	  if (leap_year(k) == true)
	     cdays += 1.0;

	  if (cdays >= rdays)
	      break;	 

	  if ((cdays+1.0) >= rdays)
	     {
	      fdays++; 	
	      break;	 
	     }
       } while (cdays < rdays);


//     printf("\n"); 	
//     if (leap_year(k) == true)
//	return fdays-1;
    
     return fdays;
}





// #define TEST


int main(int argc, char *argv[])
{

#ifdef TEST
   char st[256];	

   for (int j=1; j<24; j++)
    for (int i=1; i<24; i++)	
      {
       int v = timecalc(1976,1976+j,(double)i/24.0);

       printf("alter:%d, stunde:%d\tv:%d\t",j,i,v);	


       switch (v)
         { 
	  case 0:
	    sprintf(st,"am 28. Februar");
	    break;

	  case 1:
	    sprintf(st,"am 29. Februar");
            break;

	  case 2:
            sprintf(st,"am 1. Mrz");
            break;
         } 


       printf("%s\n",st);	
      }
#endif



   fl_initialize(&argc, argv, 0, 0, 0);
   fd_feb = create_form_feb();

   /* fill-in form initialization code */

   /* show the first form */
   fl_show_form(fd_feb->feb,FL_PLACE_CENTER,FL_FULLBORDER,"birthday planner");
   fl_do_forms();
   return 0;
}
